-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>6 then
lib.classes["DEMONHUNTER"] = {}
local t,s,n
lib.classpreload["DEMONHUNTER"] = function()
	lib.SetPower("FURY")
	lib.AddResourceBar(cfg.Power.max)
	lib.ChangeResourceBarType(cfg.Power.type)
end
lib.classes["DEMONHUNTER"][1] = function()
	cfg.talents={
		["Fel Mastery"]=IsPlayerSpell(192939),
		["Prepared"]=IsPlayerSpell(203551),
		--["RJW"]=IsPlayerSpell(116847) --Rushing Jade Wind
	}
	
	lib.AddSpell("Chaos Strike",{201427,162794})
	lib.AddSpell("Blade Dance",{210152,188499},true)
	lib.AddSpell("Metamorphosis",{191427})
	lib.AddSpell("Vengeful Retreat",{198793})
	lib.AddSpell("Fury of the Illidari",{201467})
	lib.AddAura("Metamorphosis",162264,"buff","player")
	lib.AddSpell("Demon's Bite",{162243})
	lib.AddSpell("Fel Rush",{195072})
	lib.AddSpell("Throw Glaive",{185123})
	lib.AddSpell("Eye Beam",{198013},nil,nil,true)
	lib.SetAuraFunction("Metamorphosis","OnApply",function()
		lib.ReloadSpell("Chaos Strike",{201427,162794})
		lib.ReloadSpell("Blade Dance",{210152,188499},true)
		end)
	lib.SetAuraFunction("Metamorphosis","OnFade",function()
		lib.ReloadSpell("Chaos Strike",{201427,162794})
		lib.ReloadSpell("Blade Dance",{210152,188499},true)
	end)
	
	--[[lib.AddSpell("Keg",{121253}) --Keg Smash
	lib.FixSpell("Keg","cost")
	lib.AddSpell("Haze",{115180}) --Dizzying Haze
	lib.AddSpell("Breath",{115181}) -- Breath of Fire
	lib.AddAura("Breath",123725,"debuff","target") -- Breath of Fire
	lib.AddSpell("Guard",{115295},true) -- Guard
	lib.AddAura("Shuffle",115307,"buff","player") -- Shuffle
	lib.SetTrackAura("Shuffle")
	lib.SetAuraFunction("Shuffle","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("Shuffle","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
	
	lib.AddSpell("Brew",{115308},true) -- Elusive Brew
	lib.AddAura("Brew_stacks",128939,"buff","player") -- Elusive Brew stacks
	lib.AddSpell("Purifying",{119582}) -- Purifying Brew
	lib.AddAuras("Stagger",{124274,124273},"debuff","player","player")
	
	lib.SetTrackDOT("Breath")]]
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	if cfg.talents["Prepared"] then
		table.insert(cfg.plistdps,"Vengeful Retreat_Prepared")
		table.insert(cfg.plistdps,"Fel Rush_ranged")
	end
	if cfg.talents["Fel Mastery"] then
		table.insert(cfg.plistdps,"Fel Rush_Fel Mastery")
		table.insert(cfg.plistdps,"Vengeful Retreat_ranged")
	end
	table.insert(cfg.plistdps,"Throw Glaive_range")
	
	table.insert(cfg.plistdps,"Fury of the Illidari")
	table.insert(cfg.plistdps,"Metamorphosis")
	table.insert(cfg.plistdps,"Eye Beam_aoe")
	table.insert(cfg.plistdps,"Blade Dance_aoe")
	table.insert(cfg.plistdps,"Chaos Strike")
	--table.insert(cfg.plistdps,"Throw Glaive")
	table.insert(cfg.plistdps,"Demon's Bite")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = nil
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Fel Rush_Fel Mastery"] = function()
			if cfg.Power.now<=70 or not lib.inrange("Chaos Strike") then
				return lib.SimpleCDCheck("Fel Rush")
			end
			return lib.SimpleCDCheck("Fel Rush",lib.GetSpellCD("Fel Rush",nil,lib.GetSpellMaxCharges("Fel Rush"))-cfg.gcd)
		end,
		["Fel Rush_ranged"] = function()
			if not lib.inrange("Chaos Strike") and (lib.IsLastSpell("Vengeful Retreat") or lib.IsLastSpell("Throw Glaive")) then
				return lib.SimpleCDCheck("Fel Rush")
			end
			return nil
		end,
		["Vengeful Retreat_Prepared"] = function()
			if cfg.Power.now<=75 and lib.inrange("Chaos Strike") and (lib.GetSpellCD("Vengeful Retreat")+lib.GetSpellCD("gcd")==lib.GetSpellCD("Fel Rush") or lib.GetSpellCD("Vengeful Retreat")+lib.GetSpellCD("gcd")==lib.GetSpellCD("Throw Glaive")) then
				return lib.SimpleCDCheck("Vengeful Retreat")
			end
			return nil
		end,
		["Vengeful Retreat_ranged"] = function()
			if not lib.inrange("Chaos Strike") and lib.IsLastSpell("Fel Rush") then 
				return lib.SimpleCDCheck("Vengeful Retreat")
			end
			return nil
		end,
		["Eye Beam_aoe"] = function()
			if cfg.cleaving>=2 then
				return lib.SimpleCDCheck("Eye Beam")
			end
			return nil
		end,
		["Chaos Strike"] = function()
			if cfg.cleaving>=2 and not cfg.noaue then
				if cfg.Power.now>=70 then
					return lib.SimpleCDCheck("Chaos Strike")
				end
			else
				if cfg.Power.now>=50 or lib.GetAura({"Metamorphosis"})>lib.GetSpellCD("Chaos Strike") then
					return lib.SimpleCDCheck("Chaos Strike")
				end
			end
			return nil
		end,
		["Blade Dance_aoe"] = function()
			if cfg.cleaving>=2 then
				return lib.SimpleCDCheck("Blade Dance")
			end
			return nil
		end,
		["Metamorphosis"] = function()
			if cfg.Power.now>=80 then
				return lib.SimpleCDCheck("Metamorphosis")
			end
			return nil
		end,
		["Throw Glaive_range"] = function()
			if not lib.inrange("Chaos Strike") then
				return lib.SimpleCDCheck("Throw Glaive")
			end
			return nil
		end,
	}
	
	lib.AddRangeCheck({
	{"Chaos Strike",nil},
	{"Kick",{0,0,1,1}},
	{"Throw Glaive",{0,1,0,1}},
	})
	return true
end

lib.classpostload["DEMONHUNTER"] = function()
	lib.SetInterrupt("Kick",{183752})
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Throw Glaive")
		lib.CDadd("Fury of the Illidari")
		lib.CDadd("Metamorphosis")
		lib.CDadd("Vengeful Retreat")
		lib.CDAddCleave("Eye Beam",nil,198030)
		lib.CDAddCleave("Blade Dance",nil,200685)
		lib.CDAddCleave("Fel Rush",nil,192611)
		--[[lib.CDadd("Detocs")
		lib.CDadd("Effuse")
		lib.CDAddCleave("Rushing Jade Wind",nil,148187)
		lib.CDAddCleave("Spinning Crane Kick",nil,107270)
		lib.CDAddCleave("Whirling Dragon Punch",nil,158221)
		lib.CDadd("Touch of Death")
		lib.CDadd("Serenity")
		lib.CDadd("Storm, Earth, and Fire")
		if cfg.spells["Xuen"] then
			lib.CDadd("Xuen")
			lib.CDaddTimers("Xuen","Xuen",function(self, event, unitID,spellname, rank, castid, spellID)
				if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and spellID==lib.GetSpellId("Xuen") then
					CooldownFrame_SetTimer(self.cooldown,GetTime(),45,1)
				end
			end
			,{"UNIT_SPELLCAST_SUCCEEDED"})
		end
		lib.CDadd("TB")
		lib.CDadd("Chi_Brew")
		lib.CDadd("Brew")
		lib.CDturnoff("Zen")
		lib.CDadd("Karma")
		lib.CDturnoff("Karma")
		lib.CDadd("Fortifying")
		lib.CDturnoff("Fortifying")
		lib.CDadd("Chi-Wave")
		lib.CDadd("Chi Burst")
		lib.CDadd("Sphere")
		lib.CDadd("Flying Serpent Kick")
		lib.CDadd("Crackling Jade Thunderstorm")]]
	end
end
end